From 472292a63ee4cae23a6810bcbf68339671edc3c9 Mon Sep 17 00:00:00 2001
From: Christina Fu <cfu@redhat.com>
Date: Fri, 10 Mar 2017 19:50:13 -0800
Subject: [PATCH] Bug 1419742: CMC RFE: provide Proof of Possession for
 encryption cert requests CMC encryptedPOP and decrypedPOP (Phase 1) also
 disable lraPOPwitness This patch implements the Proof of Possession for
 encryption only keys. This is a preliminary implementation with limitations.
 It does not support more than one request. ECC keys are untested. This
 version only uses default algorithms at some internal places. Not all
 limitations are listed here.

---
 base/ca/shared/conf/CS.cfg                         |   2 +-
 .../src/com/netscape/cmstools/CMCRequest.java      | 892 +++++++++++++++------
 .../src/com/netscape/cmstools/CMCResponse.java     |  26 +
 .../src/com/netscape/cmstools/CRMFPopClient.java   |   7 +
 .../netscape/cms/profile/common/EnrollProfile.java | 388 ++++++++-
 .../cms/servlet/common/CMCOutputTemplate.java      | 140 +++-
 .../servlet/profile/ProfileSubmitCMCServlet.java   | 102 ++-
 .../com/netscape/cmsutil/crypto/CryptoUtil.java    |  70 +-
 8 files changed, 1300 insertions(+), 327 deletions(-)

diff --git a/base/ca/shared/conf/CS.cfg b/base/ca/shared/conf/CS.cfg
index 3beb45c..65c3842 100644
--- a/base/ca/shared/conf/CS.cfg
+++ b/base/ca/shared/conf/CS.cfg
@@ -731,7 +731,7 @@ ca.publish.rule.instance.LdapXCertRule.predicate=
 ca.publish.rule.instance.LdapXCertRule.publisher=LdapCrossCertPairPublisher
 ca.publish.rule.instance.LdapXCertRule.type=xcert
 cmc.cert.confirmRequired=false
-cmc.lraPopWitness.verify.allow=true
+cmc.lraPopWitness.verify.allow=false
 cmc.revokeCert.verify=true
 cmc.revokeCert.sharedSecret.class=com.netscape.cms.authentication.SharedSecret
 cmc.sharedSecret.class=com.netscape.cms.authentication.SharedSecret
diff --git a/base/java-tools/src/com/netscape/cmstools/CMCRequest.java b/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
index bca569b..4485f47 100644
--- a/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
+++ b/base/java-tools/src/com/netscape/cmstools/CMCRequest.java
@@ -31,6 +31,8 @@ import java.io.PrintStream;
 import java.math.BigInteger;
 import java.security.MessageDigest;
 import java.security.NoSuchAlgorithmException;
+import java.text.SimpleDateFormat;
+import java.util.Arrays;
 import java.util.Date;
 import java.util.StringTokenizer;
 
@@ -50,22 +52,33 @@ import org.mozilla.jss.asn1.UTF8String;
 import org.mozilla.jss.crypto.CryptoToken;
 import org.mozilla.jss.crypto.DigestAlgorithm;
 import org.mozilla.jss.crypto.ObjectNotFoundException;
+import org.mozilla.jss.crypto.PrivateKey;
 import org.mozilla.jss.crypto.SignatureAlgorithm;
+import org.mozilla.jss.crypto.SymmetricKey;
 import org.mozilla.jss.crypto.X509Certificate;
 import org.mozilla.jss.pkcs10.CertificationRequest;
 import org.mozilla.jss.pkix.cmc.CMCCertId;
+import org.mozilla.jss.pkix.cmc.CMCStatusInfo;
+import org.mozilla.jss.pkix.cmc.DecryptedPOP;
+import org.mozilla.jss.pkix.cmc.EncryptedPOP;
 import org.mozilla.jss.pkix.cmc.GetCert;
 import org.mozilla.jss.pkix.cmc.IdentityProofV2;
 import org.mozilla.jss.pkix.cmc.LraPopWitness;
+import org.mozilla.jss.pkix.cmc.OtherInfo;
 import org.mozilla.jss.pkix.cmc.OtherMsg;
 import org.mozilla.jss.pkix.cmc.PKIData;
+import org.mozilla.jss.pkix.cmc.PendInfo;
+import org.mozilla.jss.pkix.cmc.ResponseBody;
 import org.mozilla.jss.pkix.cmc.TaggedAttribute;
 import org.mozilla.jss.pkix.cmc.TaggedCertificationRequest;
 import org.mozilla.jss.pkix.cmc.TaggedRequest;
 import org.mozilla.jss.pkix.cmmf.RevRequest;
 import org.mozilla.jss.pkix.cms.ContentInfo;
 import org.mozilla.jss.pkix.cms.EncapsulatedContentInfo;
+import org.mozilla.jss.pkix.cms.EncryptedContentInfo;
+import org.mozilla.jss.pkix.cms.EnvelopedData;
 import org.mozilla.jss.pkix.cms.IssuerAndSerialNumber;
+import org.mozilla.jss.pkix.cms.RecipientInfo;
 import org.mozilla.jss.pkix.cms.SignedData;
 import org.mozilla.jss.pkix.cms.SignerIdentifier;
 import org.mozilla.jss.pkix.cms.SignerInfo;
@@ -129,33 +142,31 @@ public class CMCRequest {
 
         X509Certificate cert = getCertificate(tokenName, nickname);
         if (cert != null)
-            System.out.println("got signing cert");
+            System.out.println("getPrivateKey: got signing cert");
 
         return CryptoManager.getInstance().findPrivKeyByCert(cert);
     }
 
     /**
-     * getCMCBlob create and return the enrollment request.
-     * <P>
+     * signData signs the request PKIData
      *
      * @param signerCert the certificate of the authorized signer of the CMC revocation request.
      * @param nickname the nickname of the certificate inside the token.
-     * @param rValue CRMF/PKCS10 request.
-     * @param format either crmf or pkcs10
-     * @return the CMC enrollment request encoded in base64
+     * @param pkidata the request PKIData to be signed
+     *
+     * @return the SignedData
+     *
      */
-    static ContentInfo getCMCBlob(X509Certificate signerCert, String tokenName, String nickname,
-            String[] rValue, String format, CryptoManager manager, String transactionMgtEnable,
-            String transactionMgtId,
-            String identificationEnable, String identification,
-            String identityProofEnable, String identityProofSharedSecret,
-            String identityProofV2Enable, String identityProofV2SharedSecret,
-            String identityProofV2hashAlg, String identityProofV2macAlg,
-            SEQUENCE controlSeq, SEQUENCE otherMsgSeq, int bpid) {
-
-        System.out.println("in getCMCBlob");
+    static SignedData signData(
+            X509Certificate signerCert,
+            String tokenName,
+            String nickname,
+            CryptoManager manager,
+            PKIData pkidata) {
+        String method = "signData: ";
+        SignedData req = null;
+        System.out.println(method + "begins: ");
 
-        ContentInfo fullEnrollmentReq = null;
         try {
             java.security.PrivateKey privKey = null;
             SignerIdentifier si = null;
@@ -175,8 +186,122 @@ public class CMCRequest {
                     SignerIdentifier.ISSUER_AND_SERIALNUMBER, ias, null);
             privKey = getPrivateKey(tokenName, nickname);
             if (privKey != null)
-                System.out.println("getCMCBlob: got privKey");
+                System.out.println(method + " got signer privKey");
+
+            EncapsulatedContentInfo ci = new EncapsulatedContentInfo(OBJECT_IDENTIFIER.id_cct_PKIData, pkidata);
+            DigestAlgorithm digestAlg = null;
+            SignatureAlgorithm signAlg = null;
+            org.mozilla.jss.crypto.PrivateKey.Type signingKeyType = ((org.mozilla.jss.crypto.PrivateKey) privKey)
+                    .getType();
+            if (signingKeyType.equals(org.mozilla.jss.crypto.PrivateKey.Type.RSA)) {
+                signAlg = SignatureAlgorithm.RSASignatureWithSHA256Digest;
+            } else if (signingKeyType.equals(org.mozilla.jss.crypto.PrivateKey.Type.EC)) {
+                signAlg = SignatureAlgorithm.ECSignatureWithSHA256Digest;
+            } else {
+                System.out.println("Algorithm not supported");
+                return null;
+            }
+
+            MessageDigest SHADigest = null;
+
+            byte[] digest = null;
+            try {
+                SHADigest = MessageDigest.getInstance("SHA256");
+                digestAlg = DigestAlgorithm.SHA256;
+
+                ByteArrayOutputStream ostream = new ByteArrayOutputStream();
+
+                pkidata.encode(ostream);
+                digest = SHADigest.digest(ostream.toByteArray());
+            } catch (NoSuchAlgorithmException e) {
+            }
+            System.out.println(method + "digest created for pkidata");
+
+            SignerInfo signInfo = new SignerInfo(si, null, null, OBJECT_IDENTIFIER.id_cct_PKIData, digest, signAlg,
+                    (org.mozilla.jss.crypto.PrivateKey) privKey);
+            SET signInfos = new SET();
+            signInfos.addElement(signInfo);
+
+            SET digestAlgs = new SET();
+
+            if (digestAlg != null) {
+                AlgorithmIdentifier ai = new AlgorithmIdentifier(digestAlg.toOID(), null);
+                digestAlgs.addElement(ai);
+            }
+
+            org.mozilla.jss.crypto.X509Certificate[] agentChain = manager.buildCertificateChain(signerCert);
+            SET certs = new SET();
+
+            for (int i = 0; i < agentChain.length; i++) {
+                ANY cert = new ANY(agentChain[i].getEncoded());
+                certs.addElement(cert);
+            }
+
+            req = new SignedData(digestAlgs, ci, certs, null, signInfos);
+            System.out.println(method + "signed request generated.");
+        } catch (Exception e) {
+            e.printStackTrace();
+            System.exit(1);
+        }
+
+        return req;
+    }
+
+    /**
+     * getCMCBlob create and return the enrollment request.
+     *
+     * @return the CMC enrollment request encoded in base64
+     *
+     */
+    static ContentInfo getCMCBlob(SignedData req) {
+        String method = "getCMCBlob: ";
+        System.out.println(method + "begins");
+        ContentInfo fullEnrollmentReq = new ContentInfo(req);
+        try {
+            ByteArrayOutputStream bs = new ByteArrayOutputStream();
+            PrintStream ps = new PrintStream(bs);
+
+            if (fullEnrollmentReq != null) {
+                ByteArrayOutputStream os = new ByteArrayOutputStream();
+
+                fullEnrollmentReq.encode(os);
+                ps.print(Utils.base64encode(os.toByteArray()));
+            }
+            String asciiBASE64Blob = bs.toString();
+
+            System.out.println("");
+            System.out.println("The CMC enrollment request in base-64 encoded format:");
+            System.out.println("");
+            System.out.println(asciiBASE64Blob);
+        } catch (Exception e) {
+            System.out.println(method + " Exception:" + e.toString());
+            System.exit(1);
+        }
+        return fullEnrollmentReq;
+    }
+
+    /**
+     * createPKIData creates PKIData
+     *
+     * @param rValue CRMF/PKCS10 request.
+     * @param format either crmf or pkcs10
+     * @return request in PKIData
+     */
+    static PKIData createPKIData(
+            String[] rValue, String format, String transactionMgtEnable,
+            String transactionMgtId,
+            String identificationEnable, String identification,
+            String identityProofEnable, String identityProofSharedSecret,
+            String identityProofV2Enable, String witnessSharedSecret,
+            String identityProofV2hashAlg, String identityProofV2macAlg,
+            SEQUENCE controlSeq, SEQUENCE otherMsgSeq, int bpid) {
+
+        String method = "createPKIData: ";
 
+        System.out.println(method + "begins");
+        PKIData pkidata = null;
+
+        try {
             TaggedRequest trq = null;
             PKCS10 pkcs = null;
             CertReqMsg certReqMsg = null;
@@ -185,20 +310,18 @@ public class CMCRequest {
             SEQUENCE reqSequence = new SEQUENCE();
             try {
                 for (int k = 0; k < rValue.length; k++) {
-                    System.out.println("k="+ k);
+                    System.out.println("k=" + k);
                     String asciiBASE64Blob = rValue[k];
                     byte[] decodedBytes = Utils.base64decode(asciiBASE64Blob);
 
                     if (format.equals("crmf")) {
-                        System.out.println("getCMCBlob: format: crmf");
-                        ByteArrayInputStream reqBlob =
-                                new ByteArrayInputStream(decodedBytes);
+                        System.out.println(method + " format: crmf");
+                        ByteArrayInputStream reqBlob = new ByteArrayInputStream(decodedBytes);
                         SEQUENCE crmfMsgs = null;
                         try {
-                            crmfMsgs = (SEQUENCE) new SEQUENCE.OF_Template(new
-                                    CertReqMsg.Template()).decode(reqBlob);
+                            crmfMsgs = (SEQUENCE) new SEQUENCE.OF_Template(new CertReqMsg.Template()).decode(reqBlob);
                         } catch (InvalidBERException ee) {
-                            System.out.println("getCMCBlob: This is not a crmf request. Or this request has an error.");
+                            System.out.println(method + " This is not a crmf request. Or this request has an error.");
                             System.exit(1);
                         }
                         certReqMsg = (CertReqMsg) crmfMsgs.elementAt(0);
@@ -208,25 +331,24 @@ public class CMCRequest {
                         try {
                             pkcs = new PKCS10(decodedBytes, true);
                         } catch (Exception e2) {
-                            System.out.println("getCMCBlob: Excception:"+e2.toString());
+                            System.out.println(method + " Excception:" + e2.toString());
                             System.exit(1);
                         }
                         ByteArrayInputStream crInputStream = new ByteArrayInputStream(
                                 pkcs.toByteArray());
-                        CertificationRequest cr = (CertificationRequest)
-                                CertificationRequest.getTemplate().decode(crInputStream);
+                        CertificationRequest cr = (CertificationRequest) CertificationRequest.getTemplate()
+                                .decode(crInputStream);
                         TaggedCertificationRequest tcr = new TaggedCertificationRequest(
                                 new INTEGER(bpid++), cr);
-                        trq = new
-                                TaggedRequest(TaggedRequest.PKCS10, tcr, null);
+                        trq = new TaggedRequest(TaggedRequest.PKCS10, tcr, null);
                     } else {
-                        System.out.println("getCMCBlob: Unrecognized request format: " + format);
+                        System.out.println(method + " Unrecognized request format: " + format);
                         System.exit(1);
                     }
                     reqSequence.addElement(trq);
                 }
             } catch (Exception e) {
-                System.out.println("getCMCBlob: Exception:"+ e.toString());
+                System.out.println(method + " Exception:" + e.toString());
                 System.exit(1);
             }
 
@@ -242,7 +364,7 @@ public class CMCRequest {
             // if both, V2 takes precedence
             if (identityProofV2Enable.equals("true")) {
                 bpid = addIdentityProofV2Attr(bpid, controlSeq, reqSequence,
-                        identityProofV2SharedSecret,
+                        witnessSharedSecret,
                         (identificationEnable.equals("true")) ? identification : null,
                         identityProofV2hashAlg, identityProofV2macAlg);
             } else if (identityProofEnable.equals("true")) {
@@ -250,77 +372,12 @@ public class CMCRequest {
                         identityProofSharedSecret);
             }
 
-            PKIData pkidata = new PKIData(controlSeq, reqSequence, new SEQUENCE(), otherMsgSeq);
-
-            EncapsulatedContentInfo ci = new
-                    EncapsulatedContentInfo(OBJECT_IDENTIFIER.id_cct_PKIData, pkidata);
-            // SHA1 is the default digest Alg for now.
-            DigestAlgorithm digestAlg = null;
-            SignatureAlgorithm signAlg = null;
-            org.mozilla.jss.crypto.PrivateKey.Type signingKeyType = ((org.mozilla.jss.crypto.PrivateKey) privKey).getType();
-            if (signingKeyType.equals(org.mozilla.jss.crypto.PrivateKey.Type.RSA)) {
-                signAlg = SignatureAlgorithm.RSASignatureWithSHA1Digest;
-            } else if (signingKeyType.equals(org.mozilla.jss.crypto.PrivateKey.Type.EC)) {
-                signAlg = SignatureAlgorithm.ECSignatureWithSHA1Digest;
-            } else if (signingKeyType.equals(org.mozilla.jss.crypto.PrivateKey.Type.DSA)) {
-                signAlg = SignatureAlgorithm.DSASignatureWithSHA1Digest;
-            }
-
-            MessageDigest SHADigest = null;
-
-            byte[] digest = null;
-            try {
-                SHADigest = MessageDigest.getInstance("SHA1");
-                digestAlg = DigestAlgorithm.SHA1;
-
-                ByteArrayOutputStream ostream = new ByteArrayOutputStream();
-
-                pkidata.encode(ostream);
-                digest = SHADigest.digest(ostream.toByteArray());
-            } catch (NoSuchAlgorithmException e) {
-            }
-            SignerInfo signInfo = new
-                    SignerInfo(si, null, null, OBJECT_IDENTIFIER.id_cct_PKIData, digest, signAlg,
-                            (org.mozilla.jss.crypto.PrivateKey) privKey);
-            SET signInfos = new SET();
-            signInfos.addElement(signInfo);
-
-            SET digestAlgs = new SET();
-
-            if (digestAlg != null) {
-                AlgorithmIdentifier ai = new AlgorithmIdentifier(digestAlg.toOID(), null);
-                digestAlgs.addElement(ai);
-            }
-
-            org.mozilla.jss.crypto.X509Certificate[] agentChain = manager.buildCertificateChain(signerCert);
-            SET certs = new SET();
-
-            for (int i = 0; i < agentChain.length; i++) {
-                ANY cert = new ANY(agentChain[i].getEncoded());
-                certs.addElement(cert);
-            }
-            SignedData req = new SignedData(digestAlgs, ci, certs, null, signInfos);
-            fullEnrollmentReq = new ContentInfo(req);
-            ByteArrayOutputStream bs = new ByteArrayOutputStream();
-            PrintStream ps = new PrintStream(bs);
-
-            if (fullEnrollmentReq != null) {
-                ByteArrayOutputStream os = new ByteArrayOutputStream();
-
-                fullEnrollmentReq.encode(os);
-                ps.print(Utils.base64encode(os.toByteArray()));
-            }
-            String asciiBASE64Blob = bs.toString();
-
-            System.out.println("");
-            System.out.println("The CMC enrollment request in base-64 encoded format:");
-            System.out.println("");
-            System.out.println(asciiBASE64Blob);
+            pkidata = new PKIData(controlSeq, reqSequence, new SEQUENCE(), otherMsgSeq);
         } catch (Exception e) {
             e.printStackTrace();
             System.exit(1);
         }
-        return fullEnrollmentReq;
+        return pkidata;
     }
 
     static void printUsage() {
@@ -330,16 +387,29 @@ public class CMCRequest {
         System.out.println("");
         System.out.println("The configuration file should look like as follows:");
         System.out.println("");
+        System.out.println("#decryptedPop.enable: if true, this is in response to an encryptedPOP request from the server from previous request;");
+        System.out.println("#    most all options other than the following are ignored:");
+        System.out.println("# encryptedPopResponseFile, privKeyId, decryptedPopRequestFile");
+        System.out.println("# where");
+        System.out.println("#   encryptPopResponse was the output from previous request, and is now an input to the new request that is about to be generated");
+        System.out.println("#   decryptedPopRequestFile is the output that is to be sent to the server as 2nd trip request in response to encryptedPOP");
+        System.out.println("#   privKeyId: used for decrypting the encryptedPOP and creating decryptedPOP");
+        System.out.println("");
+        System.out.println("decryptedPop.enable=false");
+        System.out.println("encryptedPopResponseFile=cmc.resp");
+        System.out.println("request.privKeyId=");
+        System.out.println("decryptedPopRequestFile=cmc.decreyptedPOP.req");
+        System.out.println("");
         System.out.println("#numRequests: Total number of PKCS10 requests or CRMF requests.");
         System.out.println("numRequests=1");
         System.out.println("");
         System.out.println("#input: full path for the PKCS10 request or CRMF request,");
         System.out.println("#the content must be in Base-64 encoded format");
         System.out.println("#Multiple files are supported. They must be separated by space.");
-        System.out.println("input=crmf1");
+        System.out.println("input=crmf.req");
         System.out.println("");
         System.out.println("#output: full path for the CMC request in binary format");
-        System.out.println("output=/u/doc/cmcReq");
+        System.out.println("output=cmc.req");
         System.out.println("");
         System.out.println("#tokenname: name of token where agent signing cert can be found (default is internal)");
         System.out.println("tokenname=internal");
@@ -349,7 +419,7 @@ public class CMCRequest {
         System.out.println("nickname=CMS Agent Certificate");
         System.out.println("");
         System.out.println("#dbdir: directory for cert8.db, key3.db and secmod.db");
-        System.out.println("dbdir=/u/smith/.netscape");
+        System.out.println("dbdir=./");
         System.out.println("");
         System.out.println("#password: password for cert8.db which stores the agent");
         System.out.println("#certificate");
@@ -360,7 +430,7 @@ public class CMCRequest {
         System.out.println("");
         System.out.println("#confirmCertAcceptance.enable: if true, then the request will");
         System.out.println("#contain this control. Otherwise, false.");
-        System.out.println("confirmCertAcceptance.enable=true");
+        System.out.println("confirmCertAcceptance.enable=false");
         System.out.println("");
         System.out.println("#confirmCertAcceptance.serial: The serial number for");
         System.out.println("#confirmCertAcceptance control");
@@ -372,7 +442,7 @@ public class CMCRequest {
         System.out.println("");
         System.out.println("#getCert.enable: if true, then the request will contain this");
         System.out.println("#control. Otherwise, false.");
-        System.out.println("getCert.enable=true");
+        System.out.println("getCert.enable=false");
         System.out.println("");
         System.out.println("#getCert.serial: The serial number for getCert control");
         System.out.println("getCert.serial=3");
@@ -382,14 +452,14 @@ public class CMCRequest {
         System.out.println("");
         System.out.println("#dataReturn.enable: if true, then the request will contain");
         System.out.println("#this control. Otherwise, false.");
-        System.out.println("dataReturn.enable=true");
+        System.out.println("dataReturn.enable=false");
         System.out.println("");
         System.out.println("#dataReturn.data: data contained in the control.");
         System.out.println("dataReturn.data=test");
         System.out.println("");
         System.out.println("#transactionMgt.enable: if true, then the request will contain");
         System.out.println("#this control. Otherwise, false.");
-        System.out.println("transactionMgt.enable=true");
+        System.out.println("transactionMgt.enable=false");
         System.out.println("");
         System.out.println("#transactionMgt.id: transaction identifier. Verisign recommend");
         System.out.println("#transactionId to be MD5 hash of publicKey.");
@@ -397,14 +467,14 @@ public class CMCRequest {
         System.out.println("");
         System.out.println("#senderNonce.enable: if true, then the request will contain this");
         System.out.println("#control. Otherwise, false.");
-        System.out.println("senderNonce.enable=true");
+        System.out.println("senderNonce.enable=false");
         System.out.println("");
         System.out.println("#senderNonce.id: sender nonce");
         System.out.println("senderNonce.id=");
         System.out.println("");
         System.out.println("#revRequest.enable: if true, then the request will contain this");
         System.out.println("#control. Otherwise, false.");
-        System.out.println("revRequest.enable=true");
+        System.out.println("revRequest.enable=false");
         System.out.println("");
         System.out.println("#revRequest.nickname: The nickname for the revoke certificate");
         System.out.println("revRequest.nickname=newuser's 102504a ID");
@@ -439,15 +509,15 @@ public class CMCRequest {
         System.out.println("#Note that if both identityProof and identityProofV2");
         System.out.println("#  are enabled, identityProofV2 takes precedence; Only one of them can be active at a time");
         System.out.println("#Supported hashAlg are:");
-        System.out.println("# SHA-1, SHA-256, SHA-384, and SHA-512");
+        System.out.println("# SHA-256, SHA-384, and SHA-512");
         System.out.println("#Supported macAlg are:");
-        System.out.println("# SHA-1-HMAC, SHA-256-HMAC, SHA-384-HMAC, and SHA-512-HMAC");
+        System.out.println("# SHA-256-HMAC, SHA-384-HMAC, and SHA-512-HMAC");
         System.out.println("identityProofV2.enable=false");
         System.out.println("identityProofV2.hashAlg=SHA-256");
         System.out.println("identityProofV2.macAlg=SHA-256-HMAC");
         System.out.println("");
-        System.out.println("#identityProofV2.sharedSecret: Shared Secret");
-        System.out.println("identityProofV2.sharedSecret=testing");
+        System.out.println("#witness.sharedSecret: Shared Secret");
+        System.out.println("witness.sharedSecret=testing");
         System.out.println("");
         System.out.println("#identification works with identityProofV2");
         System.out.println("identification.enable=false");
@@ -471,7 +541,7 @@ public class CMCRequest {
         System.out.println("");
         System.out.println("#LraPopWitness.enable: if true, then the request will contain this");
         System.out.println("#control. Otherwise, false.");
-        System.out.println("LraPopWitness.enable=true");
+        System.out.println("LraPopWitness.enable=false");
         System.out.println("");
         System.out.println("#LraPopWitness.bodyPartIDs: List of body part IDs");
         System.out.println("#Each id is separated by space.");
@@ -550,7 +620,7 @@ public class CMCRequest {
      * @param sharedSecret shared secret
      * @param hashAlgString hash algorithm
      * @param macAlgString mac algorithm
-     * cfu
+     * @author cfu
      */
     private static int addIdentityProofV2Attr(int bpid,
             SEQUENCE seq, SEQUENCE reqSequence,
@@ -926,7 +996,7 @@ public class CMCRequest {
      * @param seq
      * @param ident
      * @return
-     * cfu
+     * @author cfu
      */
     private static int addIdentificationAttr(int bpid, SEQUENCE seq, String ident) {
         UTF8String ident_s = null;
